import { RustImportMap } from './RustImportMap';
export type RustTypeManifest = {
    type: string;
    imports: RustImportMap;
    nestedStructs: string[];
};
export declare function getTypeManifestVisitor(): {
    setParentName: (name: string | null) => void;
    setNestedStruct: (value: boolean) => void;
    visitArrayValue: (node: import("src/nodes/valueNodes/ArrayValueNode").ArrayValueNode) => RustTypeManifest;
    visitBooleanValue: (node: import("src/nodes/valueNodes/BooleanValueNode").BooleanValueNode) => RustTypeManifest;
    visitEnumValue: (node: import("src/nodes/valueNodes/EnumValueNode").EnumValueNode) => RustTypeManifest;
    visitMapValue: (node: import("src/nodes/valueNodes/MapValueNode").MapValueNode) => RustTypeManifest;
    visitNoneValue: (node: import("src/nodes/valueNodes/NoneValueNode").NoneValueNode) => RustTypeManifest;
    visitNumberValue: (node: import("src/nodes/valueNodes/NumberValueNode").NumberValueNode) => RustTypeManifest;
    visitSetValue: (node: import("src/nodes/valueNodes/SetValueNode").SetValueNode) => RustTypeManifest;
    visitSomeValue: (node: import("src/nodes/valueNodes/SomeValueNode").SomeValueNode) => RustTypeManifest;
    visitStructValue: (node: import("src/nodes/valueNodes/StructValueNode").StructValueNode) => RustTypeManifest;
    visitTupleValue: (node: import("src/nodes/valueNodes/TupleValueNode").TupleValueNode) => RustTypeManifest;
    visitPublicKeyValue: (node: import("src/nodes/valueNodes/PublicKeyValueNode").PublicKeyValueNode) => RustTypeManifest;
    visitStringValue: (node: import("src/nodes/valueNodes/StringValueNode").StringValueNode) => RustTypeManifest;
    visitMapEntryValue: (node: import("src/nodes/valueNodes/MapEntryValueNode").MapEntryValueNode) => RustTypeManifest;
    visitStructFieldValue: (node: import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode) => RustTypeManifest;
    visitStructFieldType: (node: import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode) => RustTypeManifest;
    visitEnumEmptyVariantType: (node: import("src/nodes/typeNodes/EnumEmptyVariantTypeNode").EnumEmptyVariantTypeNode) => RustTypeManifest;
    visitEnumStructVariantType: (node: import("src/nodes/typeNodes/EnumStructVariantTypeNode").EnumStructVariantTypeNode) => RustTypeManifest;
    visitEnumTupleVariantType: (node: import("src/nodes/typeNodes/EnumTupleVariantTypeNode").EnumTupleVariantTypeNode) => RustTypeManifest;
    visitAmountType: (node: import("src/nodes/typeNodes/AmountTypeNode").AmountTypeNode) => RustTypeManifest;
    visitArrayType: (node: import("src/nodes/typeNodes/ArrayTypeNode").ArrayTypeNode) => RustTypeManifest;
    visitBooleanType: (node: import("src/nodes/typeNodes/BooleanTypeNode").BooleanTypeNode) => RustTypeManifest;
    visitBytesType: (node: import("src/nodes/typeNodes/BytesTypeNode").BytesTypeNode) => RustTypeManifest;
    visitDateTimeType: (node: import("src/nodes/typeNodes/DateTimeTypeNode").DateTimeTypeNode) => RustTypeManifest;
    visitEnumType: (node: import("src/nodes/typeNodes/EnumTypeNode").EnumTypeNode) => RustTypeManifest;
    visitMapType: (node: import("src/nodes/typeNodes/MapTypeNode").MapTypeNode) => RustTypeManifest;
    visitNumberType: (node: import("src/nodes/typeNodes/NumberTypeNode").NumberTypeNode) => RustTypeManifest;
    visitOptionType: (node: import("src/nodes/typeNodes/OptionTypeNode").OptionTypeNode) => RustTypeManifest;
    visitPublicKeyType: (node: import("src/nodes/typeNodes/PublicKeyTypeNode").PublicKeyTypeNode) => RustTypeManifest;
    visitSetType: (node: import("src/nodes/typeNodes/SetTypeNode").SetTypeNode) => RustTypeManifest;
    visitSolAmountType: (node: import("src/nodes/typeNodes/SolAmountTypeNode").SolAmountTypeNode) => RustTypeManifest;
    visitStringType: (node: import("src/nodes/typeNodes/StringTypeNode").StringTypeNode) => RustTypeManifest;
    visitStructType: (node: import("src/nodes/typeNodes/StructTypeNode").StructTypeNode) => RustTypeManifest;
    visitTupleType: (node: import("src/nodes/typeNodes/TupleTypeNode").TupleTypeNode) => RustTypeManifest;
    visitFixedSize: (node: import("src/nodes/sizeNodes/FixedSizeNode").FixedSizeNode) => RustTypeManifest;
    visitRemainderSize: (node: import("src/nodes/sizeNodes/RemainderSizeNode").RemainderSizeNode) => RustTypeManifest;
    visitPrefixedSize: (node: import("src/nodes/sizeNodes/PrefixedSizeNode").PrefixedSizeNode) => RustTypeManifest;
    visitConstantPdaSeed: (node: import("src/nodes/pdaSeedNodes/ConstantPdaSeedNode").ConstantPdaSeedNode) => RustTypeManifest;
    visitProgramIdPdaSeed: (node: import("src/nodes/pdaSeedNodes/ProgramIdPdaSeedNode").ProgramIdPdaSeedNode) => RustTypeManifest;
    visitVariablePdaSeed: (node: import("src/nodes/pdaSeedNodes/VariablePdaSeedNode").VariablePdaSeedNode) => RustTypeManifest;
    visitProgramLink: (node: import("src/nodes/linkNodes/ProgramLinkNode").ProgramLinkNode) => RustTypeManifest;
    visitPdaLink: (node: import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode) => RustTypeManifest;
    visitAccountLink: (node: import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode) => RustTypeManifest;
    visitDefinedTypeLink: (node: import("src/nodes/linkNodes/DefinedTypeLinkNode").DefinedTypeLinkNode) => RustTypeManifest;
    visitByteDiscriminator: (node: import("src/nodes/discriminatorNodes/ByteDiscriminatorNode").ByteDiscriminatorNode) => RustTypeManifest;
    visitFieldDiscriminator: (node: import("src/nodes/discriminatorNodes/FieldDiscriminatorNode").FieldDiscriminatorNode) => RustTypeManifest;
    visitSizeDiscriminator: (node: import("src/nodes/discriminatorNodes/SizeDiscriminatorNode").SizeDiscriminatorNode) => RustTypeManifest;
    visitPdaSeedValue: (node: import("src/nodes/contextualValueNodes/PdaSeedValueNode").PdaSeedValueNode) => RustTypeManifest;
    visitAccountBumpValue: (node: import("src/nodes/contextualValueNodes/AccountBumpValueNode").AccountBumpValueNode) => RustTypeManifest;
    visitAccountValue: (node: import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode) => RustTypeManifest;
    visitArgumentValue: (node: import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode) => RustTypeManifest;
    visitConditionalValue: (node: import("src/nodes/contextualValueNodes/ConditionalValueNode").ConditionalValueNode) => RustTypeManifest;
    visitIdentityValue: (node: import("src/nodes/contextualValueNodes/IdentityValueNode").IdentityValueNode) => RustTypeManifest;
    visitPayerValue: (node: import("src/nodes/contextualValueNodes/PayerValueNode").PayerValueNode) => RustTypeManifest;
    visitPdaValue: (node: import("src/nodes/contextualValueNodes/PdaValueNode").PdaValueNode) => RustTypeManifest;
    visitProgramIdValue: (node: import("src/nodes/contextualValueNodes/ProgramIdValueNode").ProgramIdValueNode) => RustTypeManifest;
    visitResolverValue: (node: import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode) => RustTypeManifest;
    visitRoot: (node: import("src/nodes/RootNode").RootNode) => RustTypeManifest;
    visitProgram: (node: import("src/nodes/ProgramNode").ProgramNode) => RustTypeManifest;
    visitPda: (node: import("src/nodes/PdaNode").PdaNode) => RustTypeManifest;
    visitAccount: (node: import("src/nodes/AccountNode").AccountNode) => RustTypeManifest;
    visitInstructionAccount: (node: import("src/nodes/InstructionAccountNode").InstructionAccountNode) => RustTypeManifest;
    visitInstructionArgument: (node: import("src/nodes/InstructionArgumentNode").InstructionArgumentNode) => RustTypeManifest;
    visitInstructionByteDelta: (node: import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode) => RustTypeManifest;
    visitInstruction: (node: import("src/nodes/InstructionNode").InstructionNode) => RustTypeManifest;
    visitInstructionRemainingAccounts: (node: import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode) => RustTypeManifest;
    visitError: (node: import("src/nodes/ErrorNode").ErrorNode) => RustTypeManifest;
    visitDefinedType: (node: import("src/nodes/DefinedTypeNode").DefinedTypeNode) => RustTypeManifest;
};
